﻿Imports System.Data.OleDb

Public Class frmStahlprofile
    'Datenbankzugriff auf Profile2000.mdb nach Theis, S. 321
    Shared con As New OleDbConnection
    Shared cmd As New OleDbCommand

    Public Wert1 As Single
    Public Ausgabe As String

    Shared Profil As String

    Private Sub frmStahlprofile_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        con.ConnectionString = "Provider=Microsoft.jet.OLEDB.4.0;" & "Data Source=Profile2000.mdb"
        cmd.Connection = con

        With Me
            .WindowState = 2
            .Text = "Programm  " + strPgmName + ", Version " + strVersion

            .GroupBox1.Text = "Einheiten "
            .GroupBox2.Text = "Eingaben "
            .GroupBox3.Text = "Profil aus Datenbank "
            .GroupBox4.Text = "plastische Schnittgrößen "
            .GroupBox5.Text = "Querschnittswerte "
            .GroupBox1.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox2.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox3.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox4.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox5.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)

            Call BSloeschen()
            Call Vorbelegung()

            Ausgabe = "Walzprofile aus Baustahl " + vbCrLf
            Ausgabe = Ausgabe + "Kennwerte nach DIN 18800-1:2008 und EC3" + vbCrLf
            Ausgabe = Ausgabe + "(ADO-Datenbankmodell)"
            .Label1.Text = Ausgabe
            .Label1.Font = New Font("arial", 16, FontStyle.Bold, ForeColor = Color.Black)

            'Einheiten
            .Label2.Text = "Länge"
            .Label3.Text = "Kraft"
            .TextBox1.Text = strEHL
            .TextBox2.Text = strEHF
            .TextBox3.Text = Str(gamM)

            If blnEC3 Then RadioButton2.Checked = True Else RadioButton1.Checked = True

            .Label4.Text = "Streckgrenze  fy,k = " + Str(fyk) + " N/mm²"
            .Label5.Text = "Zugfestigkeit  fu,k = " + Str(fuk) + " N/mm²"
            .Label6.Text = ""
            .Label7.Text = ""
            .Label8.Text = ""
            .Label9.Text = ""
            .Label12.Text = ""
            .Label18.Text = ""
            .Label20.Text = ""

            'Tabelle HEA aus Profildatenbank anzeigen
            Call DataGridfuellen(strProfilBez)

            strProfilBez = ""

            Call Combo1Boxfuellen()

            .ComboBox2.Items.Add("HEA")
            .ComboBox2.Items.Add("HEB")
            .ComboBox2.Items.Add("HEM")
            .ComboBox2.Items.Add("I")
            .ComboBox2.Items.Add("IPE")
            .ComboBox2.Items.Add("T")
            .ComboBox2.Items.Add("TB")
            .ComboBox2.Items.Add("U")
            .ComboBox2.Text = strProfilTab
        End With
    End Sub

    Private Sub DataGridfuellen(ByVal strProfilBez As String)
        Dim i As Integer
        cmd.CommandText = "select * from " & strProfilTab
        Dim da As New OleDbDataAdapter("Select * from " & strProfilTab, con)
        Dim ds As New DataSet
        For i = 0 To DataGridView1.Columns.Count - 1
            DataGridView1.Columns(i).Width = 50
        Next
        Try
            con.Open()
            da.Fill(ds, strProfilTab)
            DataGridView1.DataSource = ds
            DataGridView1.DataMember = strProfilTab
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        con.Close()
    End Sub

    Private Sub WerteZeigen()
        'Werte des aktuellen Dataset auslesen
        con.ConnectionString = "Provider=Microsoft.jet.OLEDB.4.0;" & "Data Source=Profile2000.mdb"
        cmd.Connection = con
        Dim da As New OleDbDataAdapter("Select * from " & strProfilTab, con)
        Dim ds As DataSet
        ds = New DataSet
        da.Fill(ds, strProfilTab)
        Dim dv As New DataView(ds.Tables(strProfilTab))
        Dim drv As DataRowView = dv(DataGridView1.CurrentRow.Index)
        Me.Label18.Text = "Record Nr. " + (DataGridView1.CurrentRow.Index + 1).ToString

        'Variablen auslesen
        Try
            db_Bez = drv("Bez")
            db_h = drv("h")
            db_b = drv("b")
            db_A = drv("A")
            db_s = drv("s")
            If strProfilTab <> "T" Then db_t = drv("t")
            Select Case strProfilTab
                Case "HEA", "IPE", "HEM", "IPE", "IPE_OV" : db_r = drv("r")
                Case "HEB" : db_r = drv("r1")
                Case "I", "IPE", "U" : db_r = drv("r2")
                Case Else : db_r = 0
            End Select
            db_IY = drv("Iy")
            db_IZ = drv("Iz")
            db_Wy = drv("Wy")
            db_Wz = drv("Wz")
            If strProfilTab = "T" Or strProfilTab = "TB" Then
                db_ey = drv("ey")
            Else
                db_Sy = drv("Sy")
            End If
            If strProfilTab <> "T" And strProfilTab <> "TB" Then db_AQ = drv("AQ")
            If strProfilTab = "HEA" Or strProfilTab = "HEB" _
            Or strProfilTab = "T" Or strProfilTab = "TB" Then
                db_d = drv("d")
            Else
                db_d = drv("d1")
            End If
        Catch
            MessageBox.Show("Fehler beim Auslesen des Records")
        End Try

    End Sub

    Public Sub Combo1Boxfuellen()
        ComboBox1.Items.Clear()
        If blnEC3 = False Then
            ComboBox1.Items.Add("S 235")
            ComboBox1.Items.Add("S 275")
            ComboBox1.Items.Add("S 355")
            ComboBox1.Items.Add("S 450")
        Else
            ComboBox1.Items.Add("S 235")
            ComboBox1.Items.Add("S 275")
            ComboBox1.Items.Add("S 355")
            ComboBox1.Items.Add("S 420")
            ComboBox1.Items.Add("S 460")
        End If
        ComboBox1.Text = "S 235"
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        'Auswahl Werkstoff
        strWerkstoffBez = ComboBox1.Text
        Call Kennwerte()
        ComboBox1.Text = strWerkstoffBez
        Call BSloeschen()
    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
        'Auswahl Profilgruppe
        Call BSloeschen()
        strProfilTab = Me.ComboBox2.Text
        'gesamte Datenbank anzeigen
        Call DataGridfuellen(strProfilBez)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Werte auslesen und berechnen
        Dim Ausgabe As String

        Call WerteZeigen()

        If blnEC3 Then
            Call plastSchn_EC3()          '5.1
        Else
            Call plastSchn_18800()        '5.1
        End If
        With Me
            .Label4.Text = "Streckgrenze  fy,k = " + fyk.ToString + " N/mm²"
            .Label5.Text = "Zugfestigkeit  fu,k = " + fuk.ToString + " N/mm²"
            .Label6.Text = "Höhe    h = " + db_h.ToString("#0.00") + " mm"
            .Label7.Text = "Fläche  A = " + db_A.ToString("#0.00") + " cm²"
            .Label8.Text = "Flächenmoment 2. Grades  Iy = " + db_IY.ToString + " cm4"
            .Label9.Text = "Flächenmoment 2. Grades  Iz = " + db_IZ.ToString + " cm4"
            If strProfilTab <> "T" Then
                .Label12.Text = "Querkraftfläche  ASteg = " + db_AQ.ToString("#0.00") + " cm²"
            Else
                .Label12.Text = ""
            End If
            If strProfilTab <> "T" And strProfilTab <> "TB" And strProfilTab <> "U" Then
                'plastische Schnittgrößen
                .Label13.Text = "Npl,d   = " + Npld.ToString("#0") + " kN"
                .Label14.Text = "Mpl,y,d = " + Mplyd.ToString("#0.0") + " kNm"
                .Label15.Text = "Mpl,z,d = " + Mplzd.ToString("#0.0") + " kNm"
                .Label16.Text = "Vpl,z,d = " + Vplzd.ToString("#0") + " kN"
                If blnEC3 Then
                    .Label17.Text = "Vpl,y,d = " + Vplyd.ToString("#0") + " kN"
                Else
                    .Label17.Text = "Vpl,y,d = " + Vplyd.ToString("#0") + " kN (alfa pl = 1,25)"
                End If
                .Label20.Text = "gamM = " + gamM.ToString("#0.0")
            Else
                Ausgabe = "Plastische Schnittgrößen sind nur für " + vbCrLf
                Ausgabe += "doppeltsymmetrische I-Profile programmiert."
                .Label13.Text = Ausgabe
            End If
            Me.Label18.Text = "Record Nr. " + (DataGridView1.CurrentRow.Index + 1).ToString + ", " + strProfilTab + " " + db_Bez
        End With
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Call DataGridfuellen(strProfilBez)
        'DataGridView1.ClearSelection()         'Focus entfernen
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        'DIN 18800
        If RadioButton1.Checked = True Then blnEC3 = False Else blnEC3 = True
        Call Combo1Boxfuellen()
        strWerkstoffBez = "S 235"
        Call Kennwerte()
        Label4.Text = ""
        Label5.Text = ""
        Call BSloeschen()
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        'EC 3
        If RadioButton2.Checked = True Then blnEC3 = True Else blnEC3 = False
        Call Combo1Boxfuellen()
        strWerkstoffBez = "S 235"
        Call Kennwerte()
        Label4.Text = ""
        Label5.Text = ""
        Call BSloeschen()
    End Sub

    Public Sub textbox1_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.Leave
        'Einheit Länge
        strEHL = TextBox1.Text
    End Sub

    Public Sub textbox2_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox2.Leave
        'Einheit Länge
        strEHF = TextBox2.Text
    End Sub

    Public Sub textbox3_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox3.Leave
        'Teisicherheitsbeiwert gammaM
        Call EingPr(TextBox3.Text)
        gamM = Wert1
    End Sub

    Public Sub EingPr(ByVal Eing1 As String)
        'Eingabeprüfung
        Dim Stelle As Integer
        Try
            Stelle = InStr(Eing1, ",")
            If Stelle > 0 Then
                Mid(Eing1, Stelle, 1) = "."
            End If
            If Eing1 = "" Then Eing1 = "0"
            Wert1 = Val(Eing1)
        Catch
            MsgBox("fehlerhafte Eingabe")
        End Try
    End Sub
End Class
